#
# This is MakeWeb, Version 2.0
# Copyright (C) 1996,1997,1998 by Hiroshi Yuki <hyuki@st.rim.or.jp>.
# http://www.st.rim.or.jp/~hyuki/
# All rights reserved.
#
$rcs = '$Id: makeweb.pl 1.4 1998/06/04 18:06:21 yuki Exp yuki $';
$debug = 0;
%config = (
    'include_filename', 0,      # MakeWeb̓̓t@Co̓t@C̃RgɊ܂߂Ȃ 1
);
#
$usage = <<"EOD";
This is MakeWeb, Version 2.0
Copyright (C) 1996,1997,1998 by Hiroshi Yuki <hyuki\@st.rim.or.jp>.
http://www.st.rim.or.jp/~hyuki/
All rights reserved.

$rcs

Usage: perl makeweb.pl input.txt > output.htm
EOD

#
%var = (
    'title',        '',
    'subtitle',     '',
    'author',       '',
    'autoinsert',   '',     # s玩Iɑ}^O
    'usenumber',    '0',    # ZNVԍȂ 1
    'usetilde',     '0',    # N̒ ~  %7E ɕϊȂ 1
);

# Color scheme names.
%colortag = (
    'none',     '',
    'white',    'TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#FF0000" VLINK="#800080" ALINK="#0000FF"',
    'offwhite',  'TEXT="#000000" BGCOLOR="#FFF0F0" LINK="#FF0000" VLINK="#800080" ALINK="#0000FF"',
    'yellow',   'TEXT="#400040" BGCOLOR="#FFFF80" LINK="#0000FF" VLINK="#008000" ALINK="#FF0080"',
    'ltyellow', 'TEXT="#000000" BGCOLOR="#FFFFC0" LINK="#0000FF" VLINK="#800080" ALINK="#FF00FF"',
    'ltblue',   'TEXT="#000000" BGCOLOR="#C0C0FF" LINK="#0000FF" VLINK="#800080" ALINK="#FF0080"',
    'midblue',  'TEXT="#000000" BGCOLOR="#8080C0" LINK="#FFFFFF" VLINK="#800080" ALINK="#FFFF00"',
    'orange',   'TEXT="#000080" BGCOLOR="#FFC040" LINK="#0000FF" VLINK="#008000" ALINK="#00FFFF"',
    'black',    'TEXT="#FFFFFF" BGCOLOR="#000000" LINK="#FFFF00" VLINK="#C0C0C0" ALINK="#C0FFC0"',
    'green',    'TEXT="#FFFFFF" BGCOLOR="#004000" LINK="#FFFF00" VLINK="#80FF80" ALINK="#00FF40"',
    'blue',     'TEXT="#FFFFFF" BGCOLOR="#000080" LINK="#FFFF00" VLINK="#8080FF" ALINK="#FF00FF"',
    'violet',   'TEXT="#FFFFFF" BGCOLOR="#800080" LINK="#00FFFF" VLINK="#80FFFF" ALINK="#00FF00"',
    'plain',    'TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#666666" ALINK="#FF00FF"',
);

#
%replacer = (
     '-[',     '<UL>',          # 0 },
     '-]',     '</UL>',         # 0 },
     '-(',     '<BLOCKQUOTE>',  # 0 },
     '-)',     '</BLOCKQUOTE>', # 0 },
     '--(',    '<PRE>',         # 1 },
     '--)',    '</PRE>',        # 0 },
     '---(',   '<PRE><SAMP>',   # 1 },
     '---)',   '</SAMP></PRE>', # 0 },
     '==(',    '<BLOCKQUOTE><PRE>',     # 1 },
     '==)',    '</PRE></BLOCKQUOTE>',   # 0 },
     '===(',   '<BLOCKQUOTE><PRE><SAMP>',   # 1 },
     '===)',   '</SAMP></PRE></BLOCKQUOTE>',    # 0 },
);

#
$newline = "\n";

# error
sub error {
    local($msg) = shift;
    $errmsg = "$file:($lineno) ERROR:$msg:$line\n";
    die $errmsg;
}

#
sub normalize {
    local($string) = shift;
    $string =~ s/&/&amp;/g;
    $string =~ s/"/&quot;/g;
    $string =~ s/</&lt;/g;
    $string =~ s/>/&gt;/g;
    return $string;
}

#
#yet:-include̒ł͎gȂ悤
sub do_contents {
    local(*FILE);
    local($id) = 0;
    local($num) = '';
    open(FILE, $file) || die "MakeWeb: I cannot open $file.\n";
    if ($var{'usenumber'}) {
        print "<BLOCKQUOTE>";
    } else {
        print "<UL>";
    }
    foreach $line (<FILE>) {
        chop($line);
        if ($line =~ /^\*(.*)/ || $line =~ /^>\*(.*)/) {
            $id++;
            if ($var{'usenumber'}) {
                print qq|<A HREF="#id$id">$id. $1</A><BR>|;
            } else {
                print qq|<LI><A HREF="#id$id">$1</A></LI>|;
            }
        }
    }
    if ($var{'usenumber'}) {
        print "</BLOCKQUOTE>";
    } else {
        print "</UL>";
    }
    close(FILE);
}

#
sub do_detailcontents {
    local(*FILE);
    local($id) = 0;
    local($did) = 0;
    local($subitem) = 0;
    open(FILE, $file) || die "MakeWeb: I cannot open $file.\n";
    if ($var{'usenumber'}) {
        $elem = 'BLOCKQUOTE';
    } else {
        $elem = 'UL';
    }
    print "<$elem>";
    foreach $line (<FILE>) {
        chop($line);
        if ($line =~ /^\*(.*)/ || $line =~ /^>\*(.*)/) {
            $id++;
            $did = 0;
            $num = "$id. " if ($var{'usenumber'});
            print qq|</$elem>$newline| if ($insubitem);
            if ($var{'usenumber'}) {
                print qq|<A HREF="#id$id">$num$1</A><BR>|;
            } else {
                print qq|<LI><A HREF="#id$id">$1</A></LI>|;
            }
            $insubitem = 0;
        } elsif ($line =~ /^-\*(.*)/ || $line =~ /^>-\*(.*)/) {
            $did++;
            $num = "$id.$did. " if ($var{'usenumber'});
            print qq|<$elem>$newline| unless ($insubitem);
            if ($var{'usenumber'}) {
                print qq|<A HREF="#id$id| . qq|did$did">$num$1</A><BR>|;
            } else {
                print qq|<LI><A HREF="#id$id| . qq|did$did">$1</A></LI>|;
            }
            $insubitem = 1;
        }
    }
    print qq|</$elem>| if ($insubitem);
    print "</$elem>";
    close(FILE);
}

# main
if (scalar(@ARGV) == 0) {
    print $usage;
    exit(-1);
}
foreach $file (@ARGV) {
    &do_file($file);
}

#
sub do_file {
    local($file) = shift;
    local(*FILE);
    local($id, $did, $insubitem) = (0, 0, 0);
    local($num) = '';

    print "<!-- $file -->$newline" if ($config{'include_filename'});

    open(FILE, $file) || die "MakeWeb: I cannot open $file.\n";
LINE:
    for ($lineno = 1; $line = <FILE>; $lineno++) {
        if ($line =~ /<-([a-zA-Z_0-9]+)>/) {
            $line =~ s/<-([a-zA-Z_0-9]+)>/$defs{$1}/gi;
            redo LINE;
        }
        chop($line);
        if ($line =~ /^;/) {
            next LINE;
        }
        if ($tag = $replacer{$line}) {
            print "\nREPLACE:" if ($debug);
            print "$tag";
            print "$newline" unless ($tag =~ /<PRE>/i);   # <PRE>̂Ƃ͉sȂ
            next LINE;
        }
        if ($line =~ /^>>(.*)/) {
            $linkcaption = $1;
            $href = $1;
            print "\nSELFLINK:" if ($debug);
            $href =~ s/~/%7E/g if ($var{'usetilde'});
            print qq|<A HREF="$href">$linkcaption</A>$newline|;
            next LINE;
        }
        if ($line =~ /^>- (.*)/) {
            $linkcaption = $1;
            $lineno++;
            $line = <FILE>;
            chop($line);
            $href = $line;
            print "\nLINK:" if ($debug);
            $href =~ s/~/%7E/g if ($var{'usetilde'});
            print qq|<LI><A HREF="$href">$linkcaption</A></LI>$newline|;
            next LINE;
        }
        if ($line =~ /^>(.*)/) {
            $linkcaption = $1;
            $lineno++;
            $line = <FILE>;
            chop($line);
            $href = $line;
            print "\nLINK:" if ($debug);
            $href =~ s/~/%7E/g if ($var{'usetilde'});
            print qq|<A HREF="$href">$linkcaption</A>$newline|;
            next LINE;
        }
        if ($line =~ /^\*(.*)/) {
            print "\nBIGHEAD:" if ($debug);
            $s = $1;
            $s =~ s/^\s+//;
            $s =~ s/^\s+$//;
            $id++;
            $did = 0;
            print qq|<A NAME="id$id"><BR></A>$newline|;
            $num = "$id. " if ($var{'usenumber'});
            print "<HR>$newline<H2>$var{'ball'}$num$s</H2>$newline";
            $insubitem = 0;
            next LINE;
        }
        if ($line =~ /^-\*(.*)/) {
            print "\nSMALLHEAD:" if ($debug);
            $s = $1;
            $s =~ s/^\s+//;
            $s =~ s/^\s+$//;
            $did++;
            $num = "$id.$did. " if ($var{'usenumber'});
            print qq|<A NAME="id$id| . qq|did$did"><BR></A>$newline|;
            print "<H3>$num$s</H3>$newline";
            $insubitem = 1;
            next LINE;
        }
        if ($line =~ /^- (.*)/) {
            print "\nLIST:" if ($debug);
            $s = $1;
            $s =~ s/^\s+//;
            $s =~ s/^\s+$//;
            print "<LI>$s</LI>$newline";
            next LINE;
        }
        if ($line =~ /^\|(.*)/) {
            print "\nVERBATIM:" if ($debug);
            $s = $1;
            print "$s$newline";
            next LINE;
        }
        if ($line =~ /^!(.*)/) {
            print "\nEMPH:" if ($debug);
            $s = $1;
            print "<STRONG>$s</STRONG>$newline";
            next LINE;
        }
        if ($line =~ /^=>(.*)/) {
            print "\nONELINEQUOTE:" if ($debug);
            $s = $1;
            print "<BLOCKQUOTE>$s</BLOCKQUOTE>$newline";
            next LINE;
        }
        # Commands that begin with '-'.
        if ($line =~ /^-(.*)/) {
            if ($line =~ /^-name=(.*)$/) {
                print "\nNAME:" if ($debug);
                print qq|<A NAME="$1"><BR></A>$newline|;
                next LINE;
            }
            if ($line =~ /^-color(.*)/) {
                if ($1 =~ /^=(.*)/) {
                    ($var{color} = $colortag{$1}) || &error("Unknown color name");
                } else {
                    print "$var{color}$newline";
                }
                next LINE;
            }
            if ($line =~ /^-background(.*)/) {
                if ($1 =~ /^=(.*)/) {
                    $var{background} = qq|BACKGROUND="$1"|;
                } else {
                    print "$var{background}$newline";
                }
                next LINE;
            }
            if ($line =~ /^-ball(.*)/) {
                if ($1 =~ /^=(.*)/) {
                    $var{ball} = "<IMG SRC=$1>";
                } else {
                    print "$var{ball}$newline";
                }
                next LINE;
            }
            foreach $varname (keys %var) {
                if ($line =~ /^-$varname=(.*)/) {
                    $var{$varname} = $1;
                    next LINE;
                } elsif ($line =~ /^-$varname$/) {
                    print "$var{$varname}$newline";
                    next LINE;
                }
            }
            foreach $defname (keys %defs) {
                if ($line =~ /^-$defname$/) {
                    print "$defs{$defname}$newline";
                    next LINE;
                }
            }
            if ($line =~ /^-include=(.*)/) {
                print "\nFILE:$1" if ($debug);
                &do_file($1);
                next LINE;
            }
            if ($line =~ /^-define=(.*)/) {
                $definename = $1;
                $lineno++;
                $line = <FILE>;
                chop($line);
                $defs{$definename} = $line;
                print qq|\nDEFINE:"$definename" -> "$line"| if ($debug);
                next LINE;
            }
            if ($line =~ /^-contents/) {
                print "\nCONTENTS:$1" if ($debug);
                &do_contents;
                next LINE;
            }
            if ($line =~ /^-detailcontents/) {
                print "\nDETAILCONTENTS:$1" if ($debug);
                &do_detailcontents;
                next LINE;
            }
            if ($line =~ /^-newline=(.*)/) {
                $onoff = $1;
                if ($onoff =~ /^off/) {
                    print "\nNEWLINE:off\n" if ($debug);
                    $newline = "";
                } else {
                    print "\nNEWLINE:on\n" if ($debug);
                    $newline = "\n";
                }
                next LINE;
            }
            if ($line =~ /^-\|(.*)/) {
                $s = &normalize($1);
                print "$s$newline";
                next LINE;
            }
        }
        if ($line =~ /^\+(.*)/) {
            print qq|<UL><LI>$1</LI></UL>$newline|;
            next LINE;
        }
        if ($line =~ /^\$(.*)/) {
            print qq|<DIV ALIGN="right">$1</DIV>$newline|;
            next LINE;
        }
        if ($line =~ /^\s*$/) {
            # s
            print "$var{autoinsert}$newline";
            next LINE;
        }
        print "$line$newline";
    }
    close(FILE);
}
